# Libraries Index

A list of Fab related electronics libraries.

- [Eagle](https://gitlab.fabcloud.org/pub/libraries/eagle)
- [KiCad](https://gitlab.fabcloud.org/pub/libraries/kicad)
- [pcb.py](https://gitlab.fabcloud.org/pub/libraries/pcb.py)

## Generator

This could be used as a generator app for the libraries. Just an idea for now, but it could feature a list of symbols and footprints that cover the item in the Fab electronics inventory. It could be possible then automatically generate and test libraries for any tool using this. An example below. How about [TOML](https://github.com/toml-lang/toml)?

**Symbols**
```
[resistor]
  [resistor.generic]
  name = "Resistor"
  symbol = "R"
  values = [
    "0 0.25W 5%", 
    "0.1 0.25W 1%", 
    "0.1 1W 5%",
    "..." 
  ]
  description = "Generic resistor"
  keywords = ["R", "RES", "resistor"]
  footprint = "SMT_1206" # Use generic footprint names when given

[potentiometer]
  [potentiometer.trimmer10k]
  name = "Trimmer_10K"
  symbol = [RV]
  description = "Trimmer Potentiometer 10K TT Electronics 23BR10KLFTR"
  keywords = ["resistor", "variable", "trimmer", "potentiometer"]
  footprint = "Trimmer_TT-Electronics_23BR10KLFTR_4.5x5x3mm" # Follow this pattern if no standard package provided
  datasheet = "https://www.ttelectronics.com/TTElectronics/media/ProductFiles/Trimmers/Datasheets/23.pdf"

[capacitor]
  [capacitor.unpolarized]
  name = "Capacitor"
  symbol = "C"
  description = "Unpolarized capacitor"
  keywords = ["cap", "capacitor"]
  footprint = "SMT_1206"

  [capacitor.polarized]
  name = "Capacitor"
  symbol = "CP"
  description = "Polarized capacitor"
  keywords = ["cap", "capacitor"]
  footprint = "THT_1x02_P5mm"

[choke]
  [choke.fixed]
  name = "Fixed inductance choke"
  symbol = "L"
  description = "Shielded Wirewound Inductor"
  keywords = ["inductor", "choke", "coil", "reactor", "magnetic", "ferrite", "bead"]
  footprint = "Choke_Panasonic_ELL-CTV_12x12x4.5mm"
  datasheet = "https://industrial.panasonic.com/cdbs/www-data/pdf/AGM0000/AGM0000CE11.pdf"
```

**Footprints**
```
[SMT]
  [SMT.1206]
  name = "SMT_1206"

[THT]

# Not sure yet...
```

**Web Interface**

Using GitLab CI it would be possible to deploy a web application every time a component is added. CI would publish a search interface and a data file that could be used by the library generators to check what is missing etc. Printing of labels would be a nice feature too!

Just an idea for now.
